/***************************************************************************
                          fleet.cpp  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <fleet.h>

Fleet::Fleet(){
}

Fleet::Fleet(Point p){
	pos = p;
	strcpy(nameid, "fleet bleh");
	if(dest.empty()) setDest(pos);
}

void Fleet::addShip(Ship s){
	ships.push_back(s);
}

void Fleet::setDest(Point d){
	dest.push_back(d);
}

int Fleet::loadCargo(int n, int t){
	cargo[t] += n;
	if(cargo[t] < 0){
		n -= cargo[t];
		cargo[t] = 0;
		return n;
		}
	if(cargoFree()<0){
		n += cargoFree();
		cargo[t] -= cargoFree();
		return n;
		}
	return n;
}

int Fleet::getShipType(int a){
	return ships[a].getType();
}

int Fleet::cargoMax(){
	int cargomax=0;
        for(int x=0;x<(int)ships.size();x++)
		cargomax += ships[x].getCargoMax();
	cout << "max: " << cargomax << endl;
        return cargomax;
}

int Fleet::cargoUsed(){
	int cargoused = 0;
	for(int x=0;x<CARGO_NUM;x++)
		cargoused += cargo[x];
		cout << "used: " << cargoused << endl; 
	return cargoused;
	}

int Fleet::cargoFree(){
	int n = cargoMax() - cargoUsed();
	cout << "free: " << n << endl;
	return n;
}

Point Fleet::getPos(){
	return pos;
}

int Fleet::fleetId(){
	return id;
}

int Fleet::size(){
	return ships.size();
}

bool Fleet::isFleet(){
	return 1;
}

vector<Point> Fleet::getDest(){
	return dest;
}

int Fleet::getSpeed(){
	//get the min speed of all the ships
	int s = INT_MAX;
	for(int x=0;x<ships.size();x++){
		if(ships[x].getSpeed() < s) s=ships[x].getSpeed();
	}
	return s;
}

void Fleet::move(){
	if(dest.size()==0) setDest(pos);//always need at least our current pos
  	if(dest.size()==1) return;

	// dest[0] == current location
	// dest[1] == next waypoint
	// we are going from p1 to p2
	Point p1 = dest[0] + 500;
	Point p2 = dest[1] + 500;
	cout << "p1, p2: "; p1.print();p2.print();cout << endl;
	speed = 6;//getSpeed();
	//get the vector b/w the 2 points
	Point p = p1 - p2;
	cout << "p: "; p.print(); cout << endl;
	// scale it down
	float n = p.length() - speed;
	if(n>0){
		cout << "p.length: " << p.length() << endl;
		n = 1-(n / p.length());
		cout << "n: " << n << endl;
		p.x = (int)(n * p.x);
		p.y = (int)(n * p.y);
		p.z = (int)(n * p.z);
		cout << "p scaled down: "; p.print(); cout << endl;
		cout << "dest: "; dest[0].print(); cout  << endl;
		dest[0] = dest[0] + p;
		cout << "dest: "; dest[0].print(); cout  << endl;
	}
	else {
		cout << "n<0" << endl;
		dest[0]=dest[1];
		for(int x=0;x<(int)dest.size()-1;x++)dest[x]=dest[x+1];
		dest.pop_back();
	}
	pos=dest[0];
	cout << "pos: " << pos.x << endl;
}

bool Fleet::checkOwner(int c){
	cout << "fleet checking owner\n";
	return 1;
}