/***************************************************************************
                          foundationcore.h  -  description
                             -------------------
    begin                : Sun May 21 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONFLICTCORE_H
#define CONFLICTCORE_H

#include <ship.h>
#include <shipInfo.h>
#include <system.h>
#include <vector>
#include <unit_def.h>
#include <fleet.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netdb.h>

#include <foundationcore.h>
#include <netengine.h>
#include <player.h>

#include "network/network.h"
/**base class of 'Foundation' (user game) and FoundationServer,
the network server.  This is made up of common
data structures and functions.
  *@author Blake Friesen
  */

class FoundationCore {
public: 
	FoundationCore();
	~FoundationCore();
	void setBuildItem(int planet, int group, int type, int quantity);

  /** a major loop
waits for network packet and handles
accordingly
 */
  void net_wait();
  /** finds a planet by it's coordinates
does a binary search and assumes
that the planets are sorted
 */
	int find_planet(Point p);
	SolarSystem planet[PLANET_NUM];
private:
protected:
	ShipInfo shipdata;
	NetEngine ne;
	Player player[MAX_CLIENTS];
/* network reception handling routines */
	virtual void handle_chat_msg(char *buf, int len);
	virtual void handle_game_join(sockaddr_in addr, char *buf, int len);
};

#endif
