/***************************************************************************
                          StarMap.cpp  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "StarMap.h"
#include <unistd.h>

#include <point.h>
#include <stdlib.h>
#include <iostream.h>
#include <math.h>
#include <stdio.h>

#include <GL/glu.h>
#include <GL/gl.h>
//#define WIDTH 530

StarMap::StarMap(int a, int b, int c, int d) : puObject(a, b, c, d)
{
	rotX = rotY = 0;
	planet = NULL;
}

void StarMap::init(){
//   	rotX = rotY = 0;
	//makeCurrent();	
	glEnable(GL_FOG);
	glEnable(GL_DEPTH_TEST);
	glFogi(GL_FOG_MODE, GL_LINEAR);
	glFogf(GL_FOG_DENSITY, 0.3);
	glFogi(GL_FOG_START, 600);  // was 50
	glFogi(GL_FOG_END, 2500); // was 1500
// 	glViewport(0,0,WIDTH,500); //original
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glFrustum(-400, 400, -400, 400, 700, -1750);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();	
	glLoadIdentity();
	makeOwner();
	makeStar();
	makeSelect();
	makeFleet();
	glTranslatef(0,0,-1400);
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();

}
/*
void StarMap::mouseMoveEvent(QMouseEvent *qm){
   if(down[0]){
      int dx = mx - qm->x();
      int dy = my - qm->y();
      mx = qm->x();
      my = qm->y();
      rotX -= dx;
      rotY -= dy;
      updateGL();
   }
}

void StarMap::mouseReleaseEvent(QMouseEvent *qm){
   down[0] = 0;
   updateGL();
}
*/

void StarMap::mousePressEvent(int mx, int my){
	down[0] = 1;
//	updateGL();
// copied from pick.cc
GLuint selectBuf[PLANET_NUM*4];
   int i,hits=0;
   //if (make_current())
    // {
      // set up the selection buffer (4 ints per hit)
      glSelectBuffer(PLANET_NUM*4, selectBuf);

      // change the render mode to selection and clear the name buffer
      glRenderMode(GL_SELECT);
      glInitNames();
      glPushName(0); // must have something on stack before callins glLoadName

      // so that we don't lose our projection/model matrix, push both
      glMatrixMode(GL_PROJECTION); glPushMatrix();
      glMatrixMode(GL_MODELVIEW); glPushMatrix();

   GLint viewport[4];
//   glViewport(0, 0, (GLint)(width()), (GLint)(height()));
   glViewport(0, abox.min[1], abox.max[0], abox.max[1]); // new viewport for pui
   glGetIntegerv(GL_VIEWPORT,viewport);
   // Create the projection matrix

   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
//	GLdouble click_x = mx;//qm->x;
//	GLdouble click_y = my;//qm->y;
//	GLdouble click_x = mx;
//	GLdouble click_y = my;
    gluPickMatrix( mx, my, 10, 10, viewport);
	glFrustum(-400.0, 400.0, -400.0, 400.0, 700.0, 1750.0); // new pui
//	glFrustum(-400.0, 400.0, -400.0, 400.0, 400.0, 1550.0);
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
//	glTranslatef(0, 0, -1000);
	glTranslatef(0.0,0.0,-1400.0); // new pui
	
        // this will set up the viewport for the selection
        //setup_pick(qm->x,qm->y);

        // draw stuff here...
//        glLoadName(1);
//        draw_cube();
//etc.
	glPushMatrix();
	glRotatef( (int)rotY/4, 1.0, 0.0, 0.0);
	glRotatef( (int)rotX/4, 0.0, 1.0, 0.0);
	glGetFloatv(GL_MODELVIEW_MATRIX, coef);
	glPopMatrix();


		for(int x = 0;x<PLANET_NUM;x++)
		{
		   	int colour = x % 6;
			glLoadName(x);
			draw_point(planet[x].getPos(), starPic[colour]);
	   	}

      // pop the projection/model matrix
      glMatrixMode(GL_PROJECTION); glPopMatrix();
      glMatrixMode(GL_MODELVIEW); glPopMatrix();

      // switch to render mode, the return value is the number of hits.
      hits=glRenderMode(GL_RENDER);
     //}

   // process the selection buffer
	cout << "number of hits: " << hits << endl;
   if (hits>0){
     for (i=0;i<hits;i++) cout << "hit: " << selectBuf[(i*4)+3] << endl;
	       //  drawgl();
			planet_clicked(selectBuf[3]);
			current_planet = selectBuf[3];
     }
// stuff ends
	glViewport(0,0,gl_width, gl_height);
}


void StarMap::paintGL(){
//   cout << "\npainting\n";
    /*
	glEnable(GL_ALPHA);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);      // alpha blending
	glEnable(GL_ALPHA_TEST);
  */
//	glEnable(GL_POINT_SMOOTH);
//	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_FOG);
	glEnable(GL_DEPTH_TEST);
    glFogi(GL_FOG_MODE, GL_LINEAR);
    glFogf(GL_FOG_DENSITY, 0.3);
    glFogi(GL_FOG_START, 600);  // was 50
    glFogi(GL_FOG_END, 2500); // was 1500
	rotX++;
//	cout << rotX << " " << rotY << endl;
	glMatrixMode(GL_PROJECTION); glPushMatrix();
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
	glEnable(GL_DEPTH_TEST);
	glViewport(0, abox.min[1], abox.max[0], abox.max[1]);
//	init();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glFrustum(-400.0, 400.0, -400.0, 400.0, 700.0, 1750.0);
//	gluPerspective(60, 1.0,2.0, 10.0);
	glMatrixMode(GL_MODELVIEW);

//	glClearColor ( 0.0, 0.0, 0.0, 1.0 ) ;
//	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();
//	gluLookAt(0.0, 0.0, 40.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
	glTranslatef(0.0,0.0,-1400.0);
      glPushMatrix();
        glRotatef( (int)rotY/4, 1.0, 0.0, 0.0);
        glRotatef( (int)rotX/4, 0.0, 1.0, 0.0);
	glColor3f(0.1, 0.1, 1.0);
	glutWireCube(750.0);
        glGetFloatv(GL_MODELVIEW_MATRIX, coef);
      glPopMatrix();

	glColor3f(0.2,0.2,1.0);
//	glutWireCube(100.0);
//	glFlush();

//	planet_sc.clear();

//	printf("star viewport: %d, %d, %d, %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);
//	double scaley = abox.max[0]/abox.max[1];
//	glTranslatef(abox.max[0]/2, abox.max[1]/2,0);
//	glScalef(0.1, 0.1,0.01);

//	glClearColor ( 0.4, 0.1, 0.1, 1.0 ) ;
//	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
/*
	glShadeModel(GL_SMOOTH);

	glBegin(GL_QUADS);
		glColor3f(0.9,0.2,0.2);
		glVertex3f(400,400,0);
		glVertex3f(400,420,0);
		glVertex3f(420,420,0);
		glVertex3f(420,400,0);
	glEnd();

	glBegin(GL_TRIANGLES);
		glColor3f(0.2,0.2,1.0);
		glVertex3f(0,10,-1.0);
		glVertex3f(0,0,-1.0);
		glVertex3f(10,0,-1.0);
		glColor3f(0.2,1.0,0.2);
		glVertex3f(2,3,-10.0);
		glVertex3f(2,2,-10.0);
		glVertex3f(3,2,-10.0);
	glEnd();
*/

//	glTranslatef(abox.max[0]/2,abox.min[1]/2,0);
//	glScalef(0.5, 0.5, 1.0);
	for(int x = 0;x<PLANET_NUM;x++){
	   	int color = x % 6;
//		cout << "x: " << x << endl;
//		planet[0].getPos();
//   	planet_sc.push_back(                    )
	draw_point(planet[x].getPos(), starPic[ color ]);
	if(x == current_planet) draw_point(planet[x].getPos(), selected);
		if(planet[x].owner == OWNER)draw_point(planet[x].getPos(), ownerPic);
   	}
//	Point p = draw_point(planet[star_selected].getPos(),selected);
//	fleet_sc.clear();
//	for(int x = 0;x<(int)fleet_pos.size();x++){
//    	fleet_sc.push_back(draw_point(fleet_pos[x], fleet_pic));
//	}

//	int last_x=0,last_y=0,last_z=0;
//	for(int x=0;x<(int)fleet_waypoints.size();x++){
//		glPushMatrix();
//		double x0 = (double)fleet_waypoints[x].x;
//		double y0 = (double)fleet_waypoints[x].y;
//		double z0 = (double)fleet_waypoints[x].z;
//		int a = (int)(x0 * coef[0] + z0 * coef[8] );
//		int b = (int)(x0 * coef[1] + y0 * coef[5] + z0 * coef[9]);
//		int c = (int)(x0 * coef[2] + y0 * coef[6] + z0 * coef[10]);
//		glCallList(fleet_pic);
//
//	if(x!=0){
//		glBegin(GL_LINES);
//		glVertex3f(a,b,c);
//		glVertex3f(last_x,last_y,last_z);
//		glEnd();
//	}
//	last_x = a;
//	last_y = b;
//	last_z = c;
//	glPopMatrix();
//	}	
	glDisable(GL_FOG);
      glMatrixMode(GL_PROJECTION); glPopMatrix();
      glMatrixMode(GL_MODELVIEW); glPopMatrix();
    	glViewport(0,0,gl_width,gl_height);
}

// draws a point and returns it's screen co-ords
Point StarMap::draw_point(Point p, int pic){
	Point pos;
    glPushMatrix();

	double x0 = (double)p.x;
    double y0 = (double)p.y;
  	double z0 = (double)p.z;
    int a = (int)(x0 * coef[0] + z0 * coef[8] );
    int b = (int)(x0 * coef[1] + y0 * coef[5] + z0 * coef[9]);
	int c = (int)(x0 * coef[2] + y0 * coef[6] + z0 * coef[10]);
    pos.x = a;
    pos.y = b;
	pos.z = c;

    glTranslatef(pos.x, pos.y, pos.z);
//	glTranslatef(0, 0, 0);
/*
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_POINTS);
		glVertex3f(pos.x, pos.y, pos.z);
	glEnd();
*/
    glCallList(pic);
	glPopMatrix();
	return pos;
}

void StarMap::makeOwner(){
	int list = glGenLists( 1 );
	glNewList(list, GL_COMPILE);
	glColor3ub(255,230,10);
	glBegin(GL_TRIANGLES);
	glVertex3f(0,12,0.1);
	glVertex3f(12,12,0.1);
	glVertex3f(12,0,0.1);
	glEnd();
	glEndList();
	ownerPic = list;
}

void StarMap::makeSelect(){
	// 24 x 24, indicates which start has been selected
	int list = glGenLists( 1 );
	glNewList(list, GL_COMPILE);
	glColor3ub(0,255,0);
	glTranslatef(-12,-12,0);
	glBegin(GL_TRIANGLES);
		glVertex3f(8,0,0.1);
		glVertex3f(0,0,0.1);
		glVertex3f(0,8,0.1);
	glEnd();
        glBegin(GL_TRIANGLES);
                glVertex3f(16,0,0.1);
                glVertex3f(24,0,0.1);
                glVertex3f(24,8,0.1);  
        glEnd();
        glBegin(GL_TRIANGLES);
                glVertex3f(24,16,0.1);
                glVertex3f(24,24,0.1);
                glVertex3f(16,24,0.1);  
        glEnd();
        glBegin(GL_TRIANGLES);
                glVertex3f(0,16,0.1);
                glVertex3f(0,24,0.1);
                glVertex3f(8,24,0.1);  
        glEnd();

	glEndList();
	selected = list;
}

void StarMap::makeFleet(){
    // 24 x 24, indicates which start has been selected
	int list = glGenLists( 1 );
	glNewList(list, GL_COMPILE);
	glColor3ub(0,255,255);
        glBegin(GL_TRIANGLES);
                glVertex3f(28,0,0); 
                glVertex3f(0,0,0);  
                glVertex3f(0,-28,0); 
        glEnd();
        glEndList();
        fleet_pic = list;
}


int StarMap::makeStar(){ 
      
char starcolors[6][3] =
	{
		{ 178, 255, 183 },
		{ 255, 255, 192 },
		{ 255, 210, 210 },
		{ 187, 199, 255 },
		{ 240, 240, 255 },
		{ 255, 255, 255 }
	};
//	glEnable(GL_ALPHA);
	      	for(int x=0;x<6;x++){
                int list = glGenLists( 1 );
                glNewList(list, GL_COMPILE);
                glBegin( GL_TRIANGLE_FAN);
		      	glColor3ub(starcolors[x][1],starcolors[x][2], starcolors[x][3]);
                glVertex3f(0, 0, 0);

//	            glColor4ub(255, 255, 255, 0);
	            glColor4ub(15, 15, 15, 0);
//		      	glColor4ub(starcolors[x][1],starcolors[x][2], starcolors[x][3], 0);
            	for(int i = 0; i<= 360;i += 45){
                	glVertex3f( 12*cos(i/57.29578), 12*sin(i/57.29578), 0.0);
            		}
                glEnd();
                glEndList();
                starPic[x]=list;
        }                                                     	
	return 0;
}

void StarMap::setPlanet(SolarSystem *p){
//	cout << "Planet set...\n";
//	printf("p: %d\n", p);
	p[0].getPos();
	planet = p;
//	printf("planet2: %d\n", p);
//	planet[0].getPos();
//	planet[1].getPos();
//	planet[2].getPos();
//	planet[3].getPos();	
}

void StarMap::setFleetPos(vector<Point> p){
	fleet_pos = p;
}

void StarMap::setFleetWaypoints(vector<Point> p){
        fleet_waypoints = p;
}

void StarMap::setStar(int s){
		star_selected=s;  
}


void StarMap::updateGL(){
	paintGL();
}

int StarMap::getCurrentPlanet()
{
	return current_planet;
}


void StarMap::draw(int a, int b)
{
//	cout << "starmap drawing: " << a << " " << b << endl;
//	paintGL();
//	int tempStyle =  ( getValue() ^ highlighted ) ? PUSTYLE_SMALL_SHADED : style ;
//	abox.draw(a, b, tempStyle, &colour[0], isReturnDefault() ) ;
	paintGL();
}

int StarMap::checkHit( int button, int updown, int x, int y)
{
//	printf("checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
	//printf("action box: %d %d %d %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);
	if((x > abox.min[0]) && (x < abox.max[0]) && (y > abox.min[1]) && (y < abox.max[1]) ) printf("inside\n");
	else return 0;
	if(updown == 0)
	{
		mx = x;
		my = y;
		mousePressEvent(x, y);
	}
	if(updown == 255)
	{
      int dx = mx - x;
      int dy = my - y;
      mx = x;
      my = y;
      rotX -= dx;
      rotY -= dy;
      paintGL();
	}
	return 1;
}