/***************************************************************************
                          StarMap.h  -  description
                             -------------------
    begin                : Tue Jan 25 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STARMAP_H
#define STARMAP_H

#include <point.h>
#include <GL/gl.h>
#include <vector>
#include <queue>
#include <plib/pu.h>
#include <sigc++/signal_system.h>
#include <unit_def.h>
#include <system.h>
// #define PLANET_NUM 50

using namespace std;
using namespace SigC;

class StarMap : puObject {
	
	public:
		StarMap(int a, int b, int c, int d);
		void mousePressEvent(int mx, int my);
		void setPlanet(SolarSystem *p);
		void setFleetPos(vector<Point> p);
		void setFleetWaypoints(vector<Point> p);
		void setStar(int);
		void init();
		void updateGL();
		void draw(int a, int b);
		int checkHit( int button, int updown, int x, int y);
		int getCurrentPlanet();
		SolarSystem *planet;
		Signal1<void,int> planet_clicked;
	private:
		void makeOwner();
		int makeStar();
		void makeFleet();
		void makeSelect();
		int starPic[16];
		int ownerPic, selected, fleet_pic;
		float coef[16];
		int star_selected, fleet_selected;
		int screen_x[PLANET_NUM], screen_y[PLANET_NUM];
//[PLANET_NUM];		
		vector<Point> fleet_pos, 
		fleet_sc, planet_sc, fleet_waypoints;
		Point draw_point(Point p, int pic);
		int current_planet;
		void paintGL();
		int mx, my;
		int rotX, rotY;
		bool down[3];
};

#endif
