/***************************************************************************
                          commandline.cpp  -  description
                             -------------------
    begin                : Wed May 10 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "commandline.h"

CommandLine::CommandLine(int a, int b, int c, int d) : puInput(a, b, c, d)
{
	setColourScheme ( 0.35, 0.4, 0.51, 1.0) ;
	fntTexFont *tim = new fntTexFont ;
    tim -> load ( "courier-bold.txf" ) ;
	puFont font ( tim, 12 ) ;
	setLegendFont(font);
	tell_player("test test test 1");
}


void CommandLine::draw(int a, int b)
{
	abox . draw ( a, b, PUSTYLE_SMALL_BEVELLED, colour, FALSE ) ;
	glColor4f(1.0,1.0,1.0,1.0);

	int xx = puGetStringWidth( legendFont, "9");
	int yy = (abox.max[1] - abox.min[1] - puGetStringHeight(legendFont) ) / 2;
	char *val = malloc(PUSTRING_MAX);
	getValue(val);
	int string_size = puGetStringWidth( legendFont, val);

	if( string_size > (abox.max[0] - abox.min[0]))
	{
		val += (int)(( string_size - (abox.max[0] - abox.min[0]))/xx);
	}
	glTranslatef(0.0,0.0,0.1);
	puDrawString( legendFont, val,
		a + abox.min[0] + xx,
		b + abox.min[1] + 10 * size_mult);
	int str_height = puGetStringHeight(legendFont);
	int i = 0;
	while( ((i* (str_height+4)) < (abox.max[1] - 20)) && i < history.size())
	{
		puDrawString(legendFont, history[i],
			a + abox.min[0] + xx,
			i * (str_height + 4));
		i++;
	}
/*	glBegin(GL_QUADS);
		glVertex3f(0.0, 0.0, 0.0 );
		glVertex3f(abox.max[0] - abox.min[0], 0.0, 0.0 );
		glVertex3f(abox.max[0] - abox.min[0], 10.0, 0.0 );
		glVertex3f(0.0, 10.0, 0.0 );
	glEnd();
*/
	glTranslatef(0.0,0.0,-0.1);
}

/*
void CommandLine::draw(int a, int b)
{
	glMatrixMode(GL_PROJECTION); glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0, 50.0, 0.0, 100.0);
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
	glLoadIdentity();
	glViewport(abox.min[0], abox.min[1], abox.max[0]-abox.min[0], abox.max[1]-abox.min[1]);
	glColor3f(0.5, 0.5, 0.0);
	glTranslatef(0.0,0.0,-0.1);
	glEnable(GL_ALPHA);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_ALPHA_TEST);

	glBegin(GL_QUADS);
		glVertex3f(0,0,-0.1);
		glVertex3f(50,0,-0.1);
		glVertex3f(50,100,-0.1);
		glVertex3f(0,100,-0.1);
	glEnd();

	glColor4f(0.2,0.2,1.0,0.15);

	glBegin(GL_QUADS);
		glVertex3f(1,1,0);
		glColor4f(0.2,0.2,1.0,1.0);
		glVertex3f(49,1,0);
		glColor4f(0.2,0.2,1.0,0.5);
		glVertex3f(49,99,0);
		glVertex3f(1,99,0);
	glEnd();

	glTranslatef(0.0,0.0,0.1);
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glViewport(0,0,gl_width,gl_height);	
};
*/

void CommandLine::input_cb(puObject *cb)
{	
//	char *val = (char *)malloc(PUSTRING_MAX);
//	memset(val, 0, PUSTRING_MAX);
//	cb->getValue ( val ) ;
//	printf("input_cb: %s\n", val);
//	send_command(0);
//	cb->setValue("");
}

/*
int CommandLine::checkHit(int button, int updown, int x, int y)
{
	send_command(0);
	return 0;
}
*/

int CommandLine::checkKey(int key, int updown )
{
/*
  if ( ! isAcceptingInput() || ! isActive () || ! isVisible () )
    return FALSE ;

  normalize_cursors () ;

  char *p ;

  switch ( key )
  {
    case PU_KEY_PAGE_UP   :
    case PU_KEY_PAGE_DOWN :
    case PU_KEY_INSERT    : return FALSE ;

    case PU_KEY_UP   :
    case PU_KEY_DOWN :
    case 0x1B:
    case '\t' :
    case '\r' :
    case '\n' :
      rejectInput () ;
      normalize_cursors () ;
      invokeCallback () ;
      break ;

    case '\b' :
      if ( cursor_position > 0 )
        for ( p = & (getStringValue() [ --cursor_position ]) ; *p != '\0' ; p++ )
          *p = *(p+1) ;
      break ;

    case 0x7F :
      if ( select_start_position != select_end_position )
      {
        char *p1 = & (getStringValue() [ select_start_position ]) ;
        char *p2 = & (getStringValue() [ select_end_position   ]) ;

        while ( *p1 != '\0' )
          *p1++ = *p2++ ;

        select_end_position = select_start_position ;
      }
      else
        for ( p = & (getStringValue() [ cursor_position ]) ; *p != '\0' ; p++ )
          *p = *(p+1) ;
      break ;

    case 0x15  : (getStringValue() [ 0 ]) = '\0' ; break ;
    case PU_KEY_HOME   : cursor_position = 0 ; break ;
    case PU_KEY_END    : cursor_position = PUSTRING_MAX ; break ;
    case PU_KEY_LEFT   : cursor_position-- ; break ;
    case PU_KEY_RIGHT  : cursor_position++ ; break ;

    default:
      if ( key < ' ' || key > 127 ) return FALSE ;

      if ( strlen ( getStringValue() ) >= PUSTRING_MAX - 1 )
        return FALSE ;	
	      p = & string [ strlen(string) ] ;
      do{
        *(p+1)=*p;
        p--;
      }while(p >= &string[cursor_position]);
      p++;
      *p = key ;
      cursor_position++ ;
      break ;
  }

  setValue ( getStringValue() ) ;
  normalize_cursors () ;
  return TRUE ;
}
*/
/*
	printf("key: %d\n", key);
*/
	if(key == 13)
	{
		char *val = malloc(PUSTRING_MAX);
		getValue(val);
		command_entered(val);
		setValue("");
	}
	return puInput::checkKey(key, updown);
}


CommandLine::~CommandLine(){
}
/**  */
void CommandLine::tell_player(char *msg)
{
	printf("adding msg... %d start:%s:end\n", history.size(), msg);
	history.push_back(msg);
}
