/***************************************************************************
                          fleet.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef FLEET_H
#define FLEET_H

#include <ship.h>
#include <point.h>
#include <unit_def.h>
#include <platform.h>

class Fleet : public Platform{
public:
	Fleet();
	Fleet(Point p);
	int loadCargo(int n, int t); // -x < n < x where x is INTMAX
	void setDest(Point d);
	vector<Point> getDest();
	Point getPos();
	void addShip(Ship s);
	int getShipType(int a);
	int fleetId();
	int size();
	bool isFleet();
	bool checkOwner(int c);
	int cargoFree();
	void move();
	int getSpeed();
	        
private:	
//	bool isFleet();
	vector<Ship> ships;
	vector<Point> dest;
	int speed;
	int id;
//	int cargoFree();
	int cargoUsed();
	int cargoMax();
};


#endif
