/***************************************************************************
                          fleetview.cpp  -  description
                             -------------------
    begin                : Tue May 2 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "fleetview.h"

FleetView::FleetView(int a, int b, int c, int d) : puObject(a, b, c, d)
{
	puGroup *pug = new puGroup(a,b);
	glMatrixMode(GL_PROJECTION); glPushMatrix();
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
	cargoChoice = new ProdChoice(5*size_mult, 160*size_mult, 192*size_mult, 217*size_mult);
	cargoChoice->width=2;

	pug->close();
	load_images();
}

void FleetView::draw(int a, int b)
{
//	printf("fleet viewport: %d, %d, %d, %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);	
/*
	glMatrixMode(GL_PROJECTION); glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0, 50.0, 0.0, 100.0);
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
	glLoadIdentity();
	glViewport(abox.min[0], abox.min[1], abox.max[0]-abox.min[0], abox.max[1]-abox.min[1]);
	glColor3f(0.5, 0.5, 0.0);
	glTranslatef(0.0,0.0,-0.1);


	glTranslatef(0.0,0.0,0.1);
	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glViewport(0,0,gl_width,gl_height);	
*/
}

void FleetView::load_images()
{
    char *cargo_img_name[] =
	{
	"images/marine.rgb",
	"images/fighter.rgb",
	"images/defense.rgb",
	"images/factory.rgb",
	"images/civilian.rgb",
	"images/tri.rgb",
	"images/deu.rgb",
	"images/mine.rgb"
	};
	vector<IMAGE *> image_list;
	vector<int> display_list;
	for(int i=0;i<CARGO_NUM;i++)
	{
		image_list.push_back(ImageLoad(cargo_img_name[i]));
		display_list.push_back(i);
	}
	cargoChoice->setImageList(image_list);
	cargoChoice->setDisplayList(display_list);
}

int FleetView::checkHit( int button, int updown, int x, int y)
{
//	printf("fleetview checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
	//printf("action box: %d %d %d %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);
	if((x > abox.min[0]) && (x < abox.max[0]) && (y > abox.min[1]) && (y < abox.max[1]) ) printf("inside fleetview\n");
	else return 0;

	return 0;
}
