/***************************************************************************
                          foundation.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// this is the actual game object
// which the UI will interact w/

#ifndef CONFLICT_H
#define CONFLICT_H

#include <ship.h>
#include <shipInfo.h>
#include <system.h>
#include <vector>
#include <unit_def.h>
#include <fleet.h>
#include <sys/socket.h>
#include <netinet/ip.h>
#include <netdb.h>

#include <foundationcore.h>
#include <netengine.h>



class Foundation : public FoundationCore
{
public:
	Foundation();
	virtual ~Foundation();
	void start();
	void listen();
	void xfer(Platform *a, Platform *b, int amount, int cargo);
        // fleet a, fleet b, value, type
	virtual void setBuildItem(int p, int g, int t, int q);
	Fleet getFleet(int f);
	void addShip(int t, Point pos);
  /**  */
  virtual void tell_player(char *);
private:
	sockaddr_in server_addr; /* remote address */
	void setServerAddr(char *addr_name);
  /**  */
  void handle_chat_msg(char *buf, int len);
protected:
	virtual void updateFleet();	
    void loadnames();
	void send_command(char *command);
	int player_id;	/* my player id */
};


#endif
