/***************************************************************************
                          planetview.cpp  -  description
                             -------------------
    begin                : Sun Apr 23 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <vector>

#include "planetview.h"

//PlanetView::PlanetView(){
//}


PlanetView::PlanetView(int a, int b, int c, int d) : puObject(a, b, c, d)
{
	update = 20;
	printf("PlanetView initializing...\n");
	puGroup *pug = new puGroup(a,b);
	glMatrixMode(GL_PROJECTION); glPushMatrix();
//	glLoadIdentity();
//	gluOrtho2D(0.0, 50.0, 0.0, 100.0);
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
//	glLoadIdentity();
//	glViewport(abox.min[0], abox.min[1], abox.max[0]-abox.min[0], abox.max[1]-abox.min[1]);
/*
	hide_menu_button = new puButton     ( 0, 0, (int)(100*size_mult), (int)(30*size_mult) );
	hide_menu_button->setValue          (    TRUE      ) ;
	hide_menu_button->setLegend         ( "Button"  ) ;
    hide_menu_button->setCallback       ( (puCallback)hide_menu_cb ) ;
	hide_menu_button->makeReturnDefault (    TRUE      ) ;
*/
    printf("\thide_menu init...\n");
	planet_name = new puText(10*size_mult,220*size_mult);
	planet_name->setLabel("Planet Name");
	planet_name->setColour(PUCOL_LABEL, 1.0, 1.0, 1.0 );
//	planet_name->reveal();
//	buildChoice = new ProdChoice(5*size_mult,100*size_mult, 95*size_mult, 160*size_mult);
//	shipChoice  = new ProdChoice(100*size_mult,100*size_mult, 190*size_mult, 160*size_mult);
	buildChoice = new ProdChoice(5*size_mult,85*size_mult, 62*size_mult, 145*size_mult);
	shipChoice  = new ProdChoice(64*size_mult,85*size_mult, 121*size_mult, 145*size_mult);
	buildQueue  = new ProdChoice(123*size_mult,85*size_mult, 192*size_mult, 145*size_mult);
	buildChoice->width=4;
	shipChoice->width=4;
	buildQueue->width=6;
    printf("\tplanet_name init...\n");
	printf("\tcargo_img_name init...\n");
	for(int i=0;i<CARGO_NUM;i++)
	{
		float x_start, y_start;
		getCargoLoc(&x_start, &y_start, i);
//		cargo[i] = new puText(10+(80* (i % 2))*size_mult, (140+(6*(i-(i%2))))*size_mult);
		cargo[i] = new puText(x_start, y_start);
//		cout << "ack" << i << endl;
		cargo[i]->setColour(PUCOL_LABEL, 1.0, 1.0, 1.0 );
		cargo[i]->setLabel("Planet Name");
//		cout << "label set..." << cargo_img_name[i] << endl;
//		cout << "image loaded..." << endl;
	}
    printf("\tcargo images loaded...\n");
	float x_start, y_start;
	getCargoLoc(&x_start, &y_start, 0);
	cargoChoice = new ProdChoice(5*size_mult, 160*size_mult, 192*size_mult, 217*size_mult);
	cargoChoice->width=2;
	pug->close();
    glPopMatrix();
	glMatrixMode(GL_PROJECTION); glPopMatrix();
	selected_cargo_img = ImageLoad("images/selected_cargo.rgb");
	//setup production choice boxes
    cargoChoice->image_clicked.connect(slot(this, &PlanetView::cargoClicked));
    buildChoice->image_clicked.connect(slot(this, &PlanetView::buildClicked));
//    starmap->planet_clicked.connect(slot(this, &FoundationGL::planet_clicked));
	printf("PlanetView done initializing...\n");
}

void PlanetView::load_images()
{
    char *cargo_img_name[] =
	{
	"images/marine.rgb",
	"images/fighter.rgb",
	"images/defense.rgb",
	"images/factory.rgb",
	"images/civilian.rgb",
	"images/tri.rgb",
	"images/deu.rgb",
	"images/mine.rgb"
	};
	vector<IMAGE *> image_list;
	vector<int> display_list;
	for(int i=0;i<CARGO_NUM;i++)
	{
		image_list.push_back(ImageLoad(cargo_img_name[i]));
		display_list.push_back(i);
	}
	cargoChoice->setImageList(image_list);
	cargoChoice->setDisplayList(display_list);
	image_list.clear();
	display_list.clear();
	for(int i=0;i<BUILDING_NUM;i++)
	{
		char *s = planet->b_template[0][i].imagename.data();
		printf("loading image %s\n\n\n", s);
		image_list.push_back(ImageLoad(s));
		display_list.push_back(i);
	}
	buildChoice->setImageList(image_list);
	buildChoice->setDisplayList(display_list);
}

void PlanetView::draw(int a, int b)
{
 //	printf("planet viewport: %d, %d, %d, %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);	
	if(!visible) return;
	glDisable(GL_DEPTH_TEST);

	/* setup labels */
	for(int i=0;i<CARGO_NUM;i++)
	{
		char *s = malloc(64);
		memset(s, 0, 64);
		sprintf(s, "%d", planet->getCargo(i));
		cargo[i]->setLabel(s);
	}
	glMatrixMode(GL_PROJECTION); glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0.0, abox.max[0]-abox.min[0], 0.0, abox.max[1]-abox.min[1]);
	glMatrixMode(GL_MODELVIEW); glPushMatrix();
	glLoadIdentity();
	glViewport(abox.min[0], abox.min[1], abox.max[0]-abox.min[0], abox.max[1]-abox.min[1]);
	glColor3f(0.3, 0.3, 0.3);
	glTranslatef(0.0,0.0,-0.1);
/*
	glEnable(GL_ALPHA);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_ALPHA_TEST);
*/
	glBegin(GL_QUADS);
		glVertex3f(0,0,-0.1);
		glVertex3f(192*size_mult,0,-0.1);
		glVertex3f(192*size_mult,240*size_mult,-0.1);
		glVertex3f(0,240*size_mult,-0.1);
		glColor3f(0.6, 0.6, 0.6);
		glVertex3f(1,0,0);
		glVertex3f(1,240*size_mult,0);
		glVertex3f(2,240*size_mult,0);
		glVertex3f(2,0,0);
	glEnd();

//	glColor4f(0.2,0.2,1.0,0.15);

/*	glBegin(GL_QUADS);
		glVertex3f(1,1,0);
		glColor4f(0.2,0.2,1.0,1.0);
		glVertex3f(49,1,0);
		glColor4f(0.2,0.2,1.0,0.5);
		glVertex3f(49,99,0);
		glVertex3f(1,99,0);
	glEnd();
*/
	glTranslatef(0.0,0.0,0.1);

    int i = 0;
	vector<int> display_list;
	display_list.clear();
	for(int j=0;j<BUILDING_NUM;j++)
	{
//		printf("can build: %d\n",planet->canBuild(0,j));
//		printf("is build: %d\n",planet->isBuilding(0,j));
//		printf("has build: %d\n\n",planet->building[j]);
		if( planet->canBuild(0,j) && !planet->isBuilding(0,j) && !planet->building[j] )
		{
		display_list.push_back(j);
		}
	}
    buildChoice->setDisplayList(display_list);

	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glViewport(0,0,gl_width,gl_height);	
}

void PlanetView::hide_menu_cb ( puObject *cb )
{
  if ( cb -> getValue () )
  {
   // main_menu_bar -> reveal () ;
    cb->setLegend ( "Hide Menu" ) ;
  }
  else
  {
//    main_menu_bar -> hide   () ;
    cb->setLegend ( "Show Menu" ) ;
  }
}

void PlanetView::setPlanet(SolarSystem *p)
{
	planet = p;
	planet_name->setLabel( planet->nameid );
}

void PlanetView::getCargoLoc(float *x, float *y, int i)
{
// gets passed pointers to 2 float vars
// and returns the position of the 'i'th cargo unit
		*x = (18+(93* (i % 2)))*size_mult;
		*y = (356-(160+(6*(i-(i%2)))))*size_mult;
}

void PlanetView::cargoClicked(int a)
{
	setbuilditem(2,a,1);
}

void PlanetView::buildClicked(int a)
{
	setbuilditem(0, a,1);
}

void PlanetView::shipClicked(int a)
{
}

void PlanetView::buildQueueClicked(int a)
{
}

int PlanetView::checkHit( int button, int updown, int x, int y)
{
//	printf("planetview checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
//	printf("action box: %d %d %d %d\n", abox.min[0], abox.min[1], abox.max[0], abox.max[1]);
	if((x > abox.min[0]) && (x < abox.max[0]) && (y > abox.min[1]) && (y < abox.max[1]) ) printf("inside planetview\n");
	else return 0;
	// translate the x, y to where this widget is
	x -= abox.min[0];
	y -= abox.min[1];
//  printf("planetview checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
    if(button || updown) return 0; // temp hack
	for(int i=0;i<CARGO_NUM;i++)
	{
		float x_offset, y_offset;
		getCargoLoc(&x_offset, &y_offset, i);
		if( (x > x_offset) && (x < x_offset+16.0*size_mult) && (y > y_offset) && (y < y_offset+16.0*size_mult))
			selected_cargo = i;
	}
	return 0;
}
