/***************************************************************************
                          planetview.h  -  description
                             -------------------
    begin                : Sun Apr 23 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PLANETVIEW_H
#define PLANETVIEW_H

#include <point.h>
#include <GL/gl.h>
#include <vector>
#include <queue>
#include <plib/pu.h>
#include <sigc++/signal_system.h>

#include <unit_def.h>
#include <system.h>
#include "prodchoice.h"
#include "image.h"

using namespace std;
using namespace SigC;

typedef void (*puCallback)(puObject *);
/**
  *@author Blake Friesen
  */

class PlanetView : public puObject, public Object{
public: 
//	PlanetView();
	PlanetView(int a, int b, int c, int d);
	void draw(int a, int b);
	void setPlanet(SolarSystem *p);
	void load_images();
    int checkHit( int button, int updown, int x, int y);
	Signal3<void,int,int,int> setbuilditem;
private:
    puButton	*hide_menu_button;
	puText		*planet_name;
	puText		*cargo[CARGO_NUM];
	ProdChoice	*buildChoice, *shipChoice, *buildQueue, *cargoChoice;
	void hide_menu_cb ( puObject *cb );
	SolarSystem	*planet;	
	IMAGE *cargo_img[CARGO_NUM];
	IMAGE *building_img[BUILDING_NUM];
	IMAGE *selected_cargo_img;
	int selected_cargo;
	void getCargoLoc(float *x, float *y, int i);
	void cargoClicked(int);
	void buildClicked(int);
	void shipClicked(int);
	void buildQueueClicked(int);
	int update;
};

#endif
