/***************************************************************************
                          platform.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef PLATFORM_H
#define PLATFORM_H

#include <stdio.h>
#include <vector>
#include "unit_def.h"
#include <point.h>
#include <queue>
#include <string>

#define DENSITY_SIZE 50
#define NAME_SIZE 32

class Platform{
public:
	Platform();
	virtual ~Platform();
	void setPop(int n);
	int getCargo(int n);
	void setTri(int n);
	void setDeu(int n);
	int giveCargo(int n, int t);
	int unloadCargo(int n, int t);
	Point getPos();

	virtual bool isFleet();
	virtual bool checkOwner(int c);
	void setName(string);
	string getName();
	virtual int cargoFree();
//	protected:
	virtual int cargoMax();
  /** sets data for object */
	virtual void setRaw(int len, char *buf);
  /* gets raw data of an object */
	virtual int getRaw(char *buf);

	Point pos;
	int cargo[CARGO_NUM];	//called cargo to be consistent w/ ships
	int owner;
	char nameid[NAME_SIZE];
};


#endif
