/***************************************************************************
                          prodchoice.cpp  -  description
                             -------------------
    begin                : Sat May 6 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "prodchoice.h"

ProdChoice::ProdChoice(int a, int b, int c, int d) : puObject(a, b, c, d)
{
	selected = glList = -1;
	selected_img = ImageLoad("images/selected_cargo.rgb");
}

void ProdChoice:: draw(int dx, int dy)
{
	if(!visible) return;
	if(glList == -1)
	{
		glDeleteLists(glList, 1);
		glList = makeList(dx, dy);
	}
	glCallList(glList);
}

int ProdChoice::makeList(int dx, int dy)
{
// printf("new list for prodchoice\n");
	int list = glGenLists( 1 );
	glNewList(list, GL_COMPILE);
	glDisable(GL_DEPTH_TEST);
 int tempStyle;
  if ( parent && ( ( parent->getType() & PUCLASS_POPUPMENU ) ||
                   ( parent->getType() & PUCLASS_MENUBAR   ) ) )
    tempStyle =  ( getValue() ^ highlighted ) ? PUSTYLE_SMALL_SHADED : style ;
  else
    tempStyle =  ( getValue() ^ highlighted ) ? -style : style ;
	abox . draw ( dx, dy, tempStyle, colour, isReturnDefault() ) ;
	glEnable(GL_TEXTURE_2D);
	if(image_list.size())
	{
	glPixelZoom( size_mult/6, size_mult/6);
	for(int i=0;i<display_list.size();i++)
	{

		float image_x;// = (x_divider*(i % width))+4*size_mult;
		float image_y;// = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
		getPosition(&image_x, &image_y, i);

		if(selected == i)
		{
//			printf("drawing selection box....\n");
			glRasterPos2f(dx+abox.min[0]+image_x-1,dy+abox.min[1]+image_y-1);
			glDrawPixels(selected_img->sizeX,selected_img->sizeY,
			GL_RGB, GL_UNSIGNED_BYTE,selected_img->data);
        }	/* end if */

		glBindTexture(GL_TEXTURE_2D, tex[ display_list[i] ]);
		glColor3ub(255, 255, 255);
		glBegin(GL_QUADS);
	
		glTexCoord2f(0.0, 0.0); glVertex3f(dx+abox.min[0]+image_x, dy+abox.min[1]+image_y, 0.0);
		glTexCoord2f(0.0, 1.0); glVertex3f(dx+abox.min[0]+image_x, dy+abox.min[1]+image_y+10.0*size_mult, 0.0);
		glTexCoord2f(1.0, 1.0); glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult, dy+abox.min[1]+image_y+10.0*size_mult, 0.0);
		glTexCoord2f(1.0, 0.0); glVertex3f(dx+abox.min[0]+image_x+10.0*size_mult, dy+abox.min[1]+image_y, 0.0);
		glEnd();
	   	}	/* end for loop */
	}	/* end if */
	glDisable(GL_TEXTURE_2D);
    glEndList();
	return list;
}

void ProdChoice::setImageList(vector<IMAGE *> list)
{
	if (list == image_list) return;
	glList = -1;
	image_list = list;

    int c;
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    for (int i = 0; i < 64; i++) {
        for (int j = 0; j < 64; j++) {
            c = ((((i&0x8)==0)^((j&0x8)==0)))*255;
            checkImage[i][j][0] = (GLubyte) c;
            checkImage[i][j][1] = (GLubyte) c;
            checkImage[i][j][2] = (GLubyte) c;
        }
    }

	glGenTextures(image_list.size(), tex);
	for(int i = 0;i<image_list.size();i++)
	{
		glBindTexture(GL_TEXTURE_2D, tex[i]);
	    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
	    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
	    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, 64,64, 0,
			GL_RGB, GL_UNSIGNED_BYTE, image_list[i]->data);
	}
}

void ProdChoice::setDisplayList(vector<int> list)
{
	if (list == display_list) return;
	glList = -1;
	glDeleteLists(glList, 1);
	display_list = list;
	printf("display list update, size: %d\n", list.size());
}

void ProdChoice::getPosition(float *x, float *y, int i)
{
	int box_width = abox.max[0] - abox.min[0];
	int box_height = abox.max[1] - abox.min[1];
	float x_divider = (float)(box_width-5) / (float)width;
	*x = (x_divider*(i % width))+4*size_mult;
	*y = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
}

int ProdChoice::checkHit( int button, int updown, int x, int y)
{
//	printf("prodchoice checkHit called: button: %d, status: %d, x: %d, y: %d\n", button, updown, x, y);
	if((x > abox.min[0]) && (x < abox.max[0]) && (y > abox.min[1]) && (y < abox.max[1]) ) printf("inside fleetview\n");
	else return 0;
	if(updown) return 0;
	x -= abox.min[0];
	y -= abox.min[1];
	for(int i=0;i<display_list.size();i++)
	{
		int j = 0;
		float image_x;// = (x_divider*(i % width))+4*size_mult;
		float image_y;// = box_height-(14+(12/width)*(i-(i%width)))*size_mult;
		getPosition(&image_x, &image_y, i);
		if( (x > image_x) && (x < image_x+16.0*size_mult) && (y > image_y) && (y < image_y+16.0*size_mult))
		{
			selected = i;
			image_clicked( display_list[i] );
			printf("selected hit!! %d\n", i);
			glList = -1;
		}
	}
	return 0;
}