/***************************************************************************
                          netengine.cpp  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <assert.h>

#include "netengine.h"

NetEngine::NetEngine()
{
	sock =  socket(AF_INET, SOCK_DGRAM, 0);
//	bindsocket(10500);
}

NetEngine::~NetEngine(){
}
/** reads a UDP packet, returns buffer and size
of buffer
 */
int NetEngine::getpacket(char *buf)
{
	int len = recv(sock, buf, MAX_PACKET_SIZE, 0);
	return len;
}

int NetEngine::getpacket(sockaddr_in *addr, int *type, int *funct, char *buf)
{
	struct proto_header st_proto_header;
	int from_len = sizeof(*addr);
	int len = recvfrom(sock, buf, MAX_PACKET_SIZE, 0, (sockaddr *)addr,
		(socklen_t *)&from_len);
	printf("packet size: %d\n", len);
	int header_len = sizeof(st_proto_header);
	memset(&st_proto_header, 0, header_len);
	memcpy(&st_proto_header, buf, header_len);
	*type = st_proto_header.type;
	*funct = st_proto_header.funct;
	printf("getpacket type: %d %d\n",buf[0], st_proto_header.funct);
	len -= header_len;
	memmove(buf, buf+header_len, len);
	assert(len > 0);	/* aborts if len is less than 0 */
	return len;
}

int NetEngine::sendpacket(sockaddr_in addr, char *buf, int len)
{
	int tolen = sizeof(addr);
	int len_sent = sendto(sock, buf, len, 0, (sockaddr *)&addr, tolen);
	printf("length sent: %d\n", len_sent);
	return len_sent;
}

/**  */
void NetEngine::sendpacket(sockaddr_in addr, int type, int funct, char *buf, int len)
{
	int tolen = sizeof(addr);
	char *packet = makepacket(buf, &len, type, funct);
	printf("sending packet: %d %d\n", packet[0], packet[4]);
	int len_sent = sendto(sock, packet, len, 0, (sockaddr *)&addr, tolen);
	printf("length sent: %d\n", len_sent);
	free(packet);
	return len_sent;
}


/** binds the socket to a specific port
should only be used on the server */
void NetEngine::bindsocket(int port)
{
	struct sockaddr_in name;
	memset((char *)&name, 0, sizeof(name));
	name.sin_family = AF_INET;
	name.sin_addr.s_addr = INADDR_ANY;
	name.sin_port = htons(port);
	
	if(bind (sock, (struct sockaddr *)&name,sizeof(name)) < 0)
	{
		perror("Error binding datagram socket.\n");
		exit(1);
	}
	printf("socket bound succesfully to port %d.\n", name.sin_port);
}

/** prepends 'data' (containing the current
packet data) with the header of the
specified type. */
char * NetEngine::makepacket(char * data, int *len, int type, int funct)
{
	printf("sending packet: %d %d\n", type, funct);
	struct proto_header st_proto_header;
	st_proto_header.type = type;
	st_proto_header.funct = funct;
	char *packet = malloc(*len + sizeof(st_proto_header));
	memset(packet, 0, *len + sizeof(st_proto_header));
	memcpy(packet, &st_proto_header, sizeof(st_proto_header));
	memcpy(packet+sizeof(st_proto_header), data, *len);
	*len += sizeof(st_proto_header);
	return packet;
}
