/***************************************************************************
                          netengine.h  -  description
                             -------------------
    begin                : Fri May 12 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef NETENGINE_H
#define NETENGINE_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/ip.h>

#include <network/network.h>

/**
  *@author Blake Friesen
  */

class NetEngine {
public: 
	NetEngine();
	~NetEngine();
	  /** reads a UDP packet, returns buffer and size
of buffer
 */
	int getpacket(char *buf);
	int getpacket(sockaddr_in *addr, int *type, int *funct, char *buf);
	/*	dest addr, packet type and function, data to send, size of data */
  /** binds the socket to a specific port
	should only be used on the server */
	void bindsocket(int port);

  /** 	prepends 'data' (containing the current
		packet data) with the header of the
		specified type. */
	char * makepacket(char * data, int *len, int type, int funct);
	void sendpacket(sockaddr_in addr, int type, int funct, char *buf, int len);
private:
	int sock;
	int sendpacket(sockaddr_in addr, char *buf, int len);
};

#endif
