/***************************************************************************
                          point.cpp  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <point.h>
#include <iostream.h>
#include <math.h>


Point::Point(){
}

Point::Point(int a, int b, int c){
   x = a;
   y = b;
   z = c;
}

bool Point::operator==(Point p){
	return( (x == p.x) && (y == p.y) && (z == p.z) );
}

void Point::operator=(Point p){
	x = p.x;
	y = p.y;
	z = p.z;
}

void Point::abs(){
	if(x<0) x = -x;
	if(y<0) y = -y;
	if(z<0) z = -z;
}

Point Point::operator+(int a){
	Point p;
	p.x = x + a;
	p.y = y + a;
	p.z = z + a;
	return p;	
}

Point Point::operator-(int a){
        Point p;
        p.x = x - a;
        p.y = y - a;
        p.z = z - a;
        return p;   
}

Point Point::operator+(Point p){
        Point a;
        a.x = p.x + x;
        a.y = p.y + y;
        a.z = p.z + z;
        return a;
}

Point Point::operator-(Point p){
	Point a;
	a.x = p.x - x;
	a.y = p.y - y;
	a.z = p.z - z;
	return a;
	
}

float Point::length(){
	float f = sqrt(x*x+y*y+z*z);
	return f; 
}

void Point::setTo(int a, int b, int c){
   x = a;
   y = b;
   z = c;
};

void Point::print(){
	cout << "x: " << x << "  y: " << y << "  z: " << z;
}
/** gets data of a Point suitable for network
transport */
int Point::getRaw(char *buf)
{
	int offset = 0;
	int size = sizeof(*this);

	memcpy(buf+offset, this, size);
	offset += size;
/*
	int size = sizeof(x);
	memcpy(buf+offset, &x, size);
	offset += size;
	size = sizeof(y);
	memcpy(buf+offset, &y, size);
	offset += size;
	size = sizeof(z);
	memcpy(buf+offset, &z, size);
	offset += size;
*/
	return offset;
}

/**  */
void Point::setRaw(char *buf, int len)
{
	int offset = 0;
	int size = sizeof(*this);
	memcpy(this, buf+offset, size);
/*
	int size = sizeof(x);
	memcpy(&x, buf+offset, size);
	offset += size;
	size = sizeof(y);
	memcpy(&y, buf+offset, size);
	offset += size;
	size = sizeof(z);
	memcpy(&z, buf+offset, size);
	offset += size;
*/
}
