/***************************************************************************
                          foundationserver.cpp  -  description
                             -------------------
    begin                : Mon Jan 31 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "foundationserver.h"

FoundationServer::FoundationServer()
{
	ne.bindsocket(5050);
	started = 0;
// temp constructor
	planet[0].setPop(1000000);
	planet[0].giveCargo(-50, FACTORY);
	planet[0].giveCargo(-50, MINE);
	planet[0].giveCargo(-5000, TRI);
	planet[0].giveCargo(-2000, DEU);
	planet[0].owner = OWNER;
	cout << "foundation initted\n\n";
	cout << planet[0].getCargo(CIVILIAN);
	Point p = planet[0].getPos();
	shipdata.addShip(1, p);
	shipdata.addShip(1, p);
	shipdata.addShip(0, p);
	shipdata.addShip(0, planet[1].getPos() );
	player_num = 0;
}

FoundationServer::~FoundationServer()
{
}

void FoundationServer::game_loop()
{
/* production/growth cycle */
	printf("game loop\n");
/* wait for incoming */
	while(!started) net_wait();
	while(1) net_wait();
}/**  */


void FoundationServer::setBuildItem(int p, int g, int t)
{
	planet[p].setBuildItem(g,t);	
}
/** finds a player by their Inet address
searchs by IP and port
returns -1 on unknown addr */
int FoundationServer::find_player(struct sockaddr_in)
{
}
/**  */
int FoundationServer::start_game()
{	
/* must send planet info to all players */
	char *buf = malloc(MAX_PACKET_SIZE);
	for(int i=0; i< PLANET_NUM; i++)
	{
		for(int j=0; j<player_num; j++)
		{
			int len = planet[i].getRaw(buf);
			ne.sendpacket( player[j].addr, PLANET_UPDATE, PLANET_UPDATE_INFO, buf, len);
		}
	}
	free(buf);
	started = 1;
	return 1;
}
/**  */
void FoundationServer::handle_game_join(sockaddr_in addr, char *buf, int len)
{
	/* initializes server side player info
	   does not actually check and make sure that the name is not taken.
	*/
	struct game_join st_game_join;
	assert(len == sizeof(st_game_join));
	memcpy(&st_game_join, buf, sizeof(st_game_join));
	player[player_num].addr = addr;
	strcpy(player[player_num].name, st_game_join.player_name);
	st_game_join.player_id = player_num;
	ne.sendpacket(addr, GAME_UPDATE, GAME_JOIN,
			(char *)&st_game_join, sizeof(st_game_join));
	player_num++;
}
/**  */
void FoundationServer::handle_chat_msg(char *buf, int len)
{
	printf("server got chat msg.\n");
	for(int i = 0;i<player_num;i++)
	{
		ne.sendpacket(player[i].addr, GAME_UPDATE, CHAT_MSG,
			buf, len);
	}
}
