/***************************************************************************
                          shipInfo.cpp  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <shipInfo.h>
#include <fstream.h>
#include <unit_def.h>
#include <string>

ShipInfo::ShipInfo(){
	loadShipSpecs();
}

void ShipInfo::loadShipSpecs(){
	Ship s;
	int id, cargo, pass, guns, canons, tor, speed = 0;
	ifstream input("shipspecs.txt");
	for(int x=0;x<T_NUM;x++)
	{
		input >> id;
		input >> cargo;
		input >> guns;
		input >> canons;
		input >> tor;
		input >> speed;
		s.set(guns, canons, tor, pass, cargo);
		s.setType(x);
		shiptype_list.push_back(s);
	}
}

int ShipInfo::xferFleet(int fa, int fb, int n, int t){
	// from fa to fb 
	int amount = fleet[fa].loadCargo( -n, t);
	int loaded = fleet[fb].loadCargo(amount, t);
	if( (amount-loaded)>0 ) fleet[fa].loadCargo(amount-loaded,t);
	return amount;
}

int ShipInfo::loadFleet(int f, int n, int t){
	return fleet[f].loadCargo(n, t);
}

void ShipInfo::moveFleet(){
	for(int x=0;x<(int)fleet.size();x++){
		fleet[x].move();
	}
}

Fleet ShipInfo::getFleet(int f){
	if ((int)fleet.size()>f) return fleet[f];
	cerr << "Fleet reference out of range: " << fleet.size() << endl;
	exit(1);
}

void ShipInfo::addShip(int s, Point p){
	Ship newship;
	newship = shiptype_list[s];
	cout << "adding ship type " << newship.getCargoMax() << endl;
	for(int x=0;x<(int)fleet.size();x++){
		cout << "checking fleet pos\n";
		if( fleet[x].getPos()==p ){
			fleet[x].addShip(newship);
			cout << "adding to a fleet\n";
			return;
			}
		}
	cout << "creating new fleet " << fleet.size() << endl;
	Fleet f(p);
	f.addShip(newship);
	fleet.push_back(f);
}

vector<Fleet *> ShipInfo::getFleet(Point p){
	vector<Fleet *> a;
	for(int x=0;x<(int)fleet.size();x++)
		if(fleet[x].getPos()==p) a.push_back(&(fleet[x])); 
	return a;
}

vector<Point> ShipInfo::getFleetPos(){
	vector<Point> a;
	for(int x=0;x<(int)fleet.size();x++) a.push_back(fleet[x].getPos());
	return a;
}

void ShipInfo::xfer(Platform *a, Platform *b, int amount, int cargo){
	if(a->getPos() != b->getPos() ) return;
  	int q = b->cargoFree();
  	if(q < amount) amount = q; 
  	int n = a->giveCargo(amount, cargo); 
  	int m = b->giveCargo(-n, cargo); 
}
