/***************************************************************************
                          shipInfo.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// object that store ship stats, locations, fleets, etc.
// basically modularizes all ship info for the Foundation obj.

#ifndef SHIPINFO_H
#define SHIPINFO_H

#include "shipDesign.h"
#include "unit_def.h"
#include <vector>
#include <ship.h>
#include <prodItem.h>
#include <fleet.h>

class ShipInfo{
public:
	ShipInfo();
	void addShip(int s, Point p);
	void setDest(int f, Point dest);
	int xferFleet(int fa, int fb, int n, int t);
	void xfer(Platform *a, Platform *b, int amount, int cargo);	
	int loadFleet(int f, int n, int t);
	void moveFleet();
	Fleet getFleet(int f);
	vector<Fleet *> getFleet(Point p);
	vector<Point> getFleetPos();//returns a list of all the fleet pos
	
private:
	void loadShipSpecs();
	vector<Ship> shiptype_list;
	vector<Fleet> fleet;
	int findFleet(Point p);
};


#endif
