/***************************************************************************
                          system.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SOLARSYSTEM_H
#define SOLARSYSTEM_H

#include <vector>
#include "unit_def.h"
#include <prodItem.h>
#include <point.h>
#include <queue>
#include <platform.h>
#include <shipInfo.h>

#define DENSITY_SIZE 50

using namespace std;
//using namespace SigC;

//ProdItem b_template[G_NUM][T_NUM];
//void loadcosts();

class SolarSystem : public Platform{
public:
	SolarSystem();
	vector <int> getneeds();
	void grow();
	bool produce();
	void setBuildItem(int g, int t);
	bool isBuilding(int g, int t);
	bool canBuild(int g, int t);
	static ShipInfo *shipdata;
	bool isFleet();
	int getOwner();
	bool checkOwner(int c);

	static ProdItem b_template[G_NUM][T_NUM];
	static void loadcosts();
  /**  */
	int getRaw(char *buf);
	bool building[BUILDING_NUM];

private:
	vector<int> make_density();

	queue<ProdItem> prod_q;
	ProdItem currentItem;
	int popmax; // no actual limit to pop max, just limit to cheap growth
	float tri_density[DENSITY_SIZE];
	float deu_density[DENSITY_SIZE];
	float x_range[DENSITY_SIZE];

};


#endif
