/***************************************************************************
                          unit_def.h  -  description
                             -------------------
    begin                : Sat Jan 1 2000
    copyright            : (C) 2000 by Blake Friesen
    email                : umfrie64@cc.umanitoba.ca
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// (temp?) definitions
// syntax:
// define name id#
#ifndef UNIT_DEF_H
#define UNIT_DEF_H

#define PLANET_NUM 100
#define G_NUM 3  // number of groups
				// ie. cargo, buildings, ships
#define T_NUM 16 // max. number of items per group
#define OWNER 1

extern float size_mult;
extern int gl_width;
extern int gl_height;

/*
float size_mult;
int gl_width, gl_height;
*/
/*
#define WIDTH 1280
#define HEIGHT 1024
#define SIZE_MULT 2.0
*/
/*
#define WIDTH 1152
#define HEIGHT 864
#define SIZE_MULT 1.8
*/
/*
#define WIDTH 1024
#define HEIGHT 768
#define SIZE_MULT 1.6
*/
/*
#define WIDTH 800
#define HEIGHT 600
#define SIZE_MULT 1.2
*/
/*
#define WIDTH 640
#define HEIGHT 480
#define SIZE_MULT 1.0
*/
/*
Most units can be transported.
Some units have certain buildings as pre-requisites.
units:
	marines		0x120 // 1 0010 0000
	people		0	// can't build
	fighters	0x131	
	factories	0x102
	mines (not transportable) 0x03
	planetary defense	0x124
buildings:
	null		0 // nothing required
	shipyard	0x01	// 0 0000 0001
	barracks	0x02	// 0 0000 0010
	starbase	0x03	// 0 0000 0011
	mil research	0x04
	civ research	0x05
	stargate	0x36
	planetary shield	0x07
*/


#define CARGO_NUM 8

#define UNIT_OFFSET 0x20
#define UNIT_NUM 8
#define MARINE		0	// marine, requires barracks	
#define FIGHTER		1	// space fighter, requires starbase
#define DEFENSE		2
#define FACTORY		3
#define CIVILIAN	4
#define TRI		5
#define DEU		6
#define MINE		7

// one per planet only
#define BUILDING_OFFSET 0x0
#define BUILDING_NUM 8	// 3 for now
#define BUILDING_1	0x2001	// shipyard
#define SHIPYARD	0x2001
#define BUILDING_2	0x2002	// barracks
#define BARRACKS	0x2002
#define BUILDING_3	0x2003	// starbase
#define STARBASE	0x2003	
#define BUILDING_4	0x2004	// mil. research lab
#define MIL_RESEARCH	0x2004	
#define BUILDING_5	0x2005	// civ. research lab
#define CIV_RESEARCH	0x2005	
#define BUILDING_6	0x2006
#define SHEILD		0x2006

#define SHIP_OFFSET 0
#define SHIP_NUM 16
#define SHIP_0	0
#define SHIP_1	1
#define SHIP_2	2
#define SHIP_3	3
#define SHIP_4	4
#define SHIP_5	5
#define SHIP_6	6
#define SHIP_7	7
#define SHIP_8	8	
#define SHIP_9	9	
#define SHIP_10	10
#define SHIP_11	11
#define SHIP_12	12
#define SHIP_13 13
#define SHIP_14 14
#define SHIP_15 15

#endif
